// Distributed under GNU General Public License (see license.txt for details).
//
//  Copyright (c) 2012 Tianbao Yang.
//  All Rights Reserved.
//============================================================================================
// File Name: objective.h
// header for evaluating objective and loss
//==============================================================================================


#ifndef OBJECTIVE_H_
#define OBJECTIVE_H_

//*****************************************************************************
// Included Files
//*****************************************************************************
#include <iostream>
#include <ostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <iterator>
#include <vector>
#include <set>
#include <sstream>
#include <ctime>
#include <cmath>
#include <algorithm>
#include <type_traits>
#include "simple_sparse_vec_hash.h"
#include "WeightVector.h"
#include "data_set.h"
#define INF HUGE_VAL


void  objective(Dataset& Data, long& iter_calc_obj_time, std::vector<double>& phi_loss_error_norm, 
		        WeightVector& W, WeightVector& AvgW, uint count, int avg, int ls, double l1s, int myclass=1);

void  objective(Dataset& Data, long& iter_calc_obj_time, std::vector<double>& phi_loss_error_norm, WeightVector& W,
		        int ls, double l1s, int myclass=1);

void  objective(Dataset& Data, long& iter_calc_obj_time, std::vector<double>& loss, std::vector<double>& error, 
		        WeightVector& W, WeightVector& AvgW, int avg, int ls, int myclass=1, std::streambuf* osbuf = nullptr);

void  objective(Dataset& Data, std::vector<int> my_Class, long& iter_calc_obj_time, std::vector<double>& phi_loss_error_norm, 
		        std::vector<WeightVector>&Wc, std::vector<WeightVector>& AvgWc, uint count, int avg, int ls, double l1s);

void  objective(Dataset& Data, std::vector<int> my_Class, long& iter_calc_obj_time, std::vector<double>& test_error, 
		        std::vector<WeightVector>&Wc, std::vector<WeightVector>& AvgWc,  int avg, int ls, std::streambuf* osbuf = nullptr);

void compute_obj_dual_gap(ulong n, uint nc, std::vector<double>& phi_loss_norm, std::vector<double>& total_phi_loss, 
		            double conj_val, double lambda, double l1s, uint wsize, uint count,
		            std::vector< std::vector<double> >&obj_vecc, std::vector< std::vector<double> >&dual_gap_vecc, 
		            double& max_dual_gap);

#endif /*OBJECTIVE_H_*/
